import { ConfigOptionType, ExtractValueType, OptionMappedType, OptionObjectValueType, OptionValueType } from '../../types';
import { COMPONENT_COLOR_TYPE } from '../../enum/constants';
import { StyleValue } from 'vue';
export declare function isOptionObjectValueType(option: OptionValueType): option is OptionObjectValueType;
export default function useOptionMethods(): {
    optionValue: <Option extends OptionValueType, Config extends ConfigOptionType<Option>, Model extends ExtractValueType<Option, Config>>(option: Option, config?: Config | undefined) => Model;
    optionLabel: <Option_1 extends OptionValueType, Config_1 extends ConfigOptionType<Option_1>>(option: Option_1, config?: Config_1 | undefined) => string;
    optionIcon: <Option_2 extends OptionValueType, Config_2 extends ConfigOptionType<Option_2>>(option: Option_2, config?: Config_2 | undefined) => string;
    optionDisabled: <Option_3 extends OptionValueType, Config_3 extends ConfigOptionType<Option_3>>(option: Option_3, config?: Config_3 | undefined) => boolean;
    optionIconColorHex: <Option_4 extends OptionValueType, Config_4 extends ConfigOptionType<Option_4>>(option: Option_4, config?: Config_4 | undefined) => string;
    optionClass: <Option_5 extends OptionValueType, Config_5 extends ConfigOptionType<Option_5>>(option: Option_5, config: Config_5) => string;
    optionStyle: <Option_6 extends OptionValueType, Config_6 extends ConfigOptionType<Option_6>>(option: Option_6, config?: Config_6 | undefined) => string;
    optionSearchKeys: <Option_7 extends OptionValueType, Config_7 extends ConfigOptionType<Option_7>>(option: Option_7, config?: Config_7 | undefined) => Array<string>;
    optionSearch: <Option_8 extends OptionValueType, Config_8 extends ConfigOptionType<Option_8>>(query: string, options: Option_8[], config?: Config_8 | undefined) => Option_8[];
    optionColor: <Option_9 extends OptionValueType, Config_9 extends ConfigOptionType<Option_9>>(option: Option_9, config?: Config_9 | undefined) => COMPONENT_COLOR_TYPE;
    optionListMap: <Option_10 extends OptionValueType, Config_10 extends ConfigOptionType<Option_10>>(options: Option_10[], config?: Config_10 | undefined) => OptionMappedType<Option_10, Config_10>[];
    optionIconStyle: <Option_11 extends OptionValueType, Config_11 extends ConfigOptionType<Option_11>>(option: Option_11, config?: Config_11 | undefined) => StyleValue;
};
